proc ddhcswap_makeframe {} {

   toplevel .ddhcswap
   wm title .ddhcswap "Coordinate swap"
   wm transient .ddhcswap [winfo toplevel [winfo parent .ddhcswap]]

   set width 6
   set ypad 3

   ###########################################################################

   # X
   set cf [frame .ddhcswap.frmx]
   pack $cf -side top -fill x
   label $cf.lbl -text "Swap X to "
   grid $cf.lbl -row 1 -column 0 -sticky w
   radiobutton $cf.rbx -text "X " -variable ddhcswap_swapx -value 0
   radiobutton $cf.rby -text "Y " -variable ddhcswap_swapx -value 1
   radiobutton $cf.rbz -text "Z " -variable ddhcswap_swapx -value 2
   grid $cf.rbx -row 1 -column 1 -sticky w
   grid $cf.rby -row 1 -column 2 -sticky w
   grid $cf.rbz -row 1 -column 3 -sticky w
   checkbutton $cf.neg -text "negate" -variable ddhcswap_negx
   grid $cf.neg -row 1 -column 4 -sticky w

   # Y
   set cf [frame .ddhcswap.frmy]
   pack $cf -side top -fill x
   label $cf.lbl -text "Swap Y to "
   grid $cf.lbl -row 1 -column 0 -sticky w
   radiobutton $cf.rbx -text "X " -variable ddhcswap_swapy -value 0
   radiobutton $cf.rby -text "Y " -variable ddhcswap_swapy -value 1
   radiobutton $cf.rbz -text "Z " -variable ddhcswap_swapy -value 2
   grid $cf.rbx -row 1 -column 1 -sticky w
   grid $cf.rby -row 1 -column 2 -sticky w
   grid $cf.rbz -row 1 -column 3 -sticky w
   checkbutton $cf.neg -text "negate" -variable ddhcswap_negy
   grid $cf.neg -row 1 -column 4 -sticky w

   # Z
   set cf [frame .ddhcswap.frmz]
   pack $cf -side top -fill x
   label $cf.lbl -text "Swap Z to "
   grid $cf.lbl -row 1 -column 0 -sticky w
   radiobutton $cf.rbx -text "X " -variable ddhcswap_swapz -value 0
   radiobutton $cf.rby -text "Y " -variable ddhcswap_swapz -value 1
   radiobutton $cf.rbz -text "Z " -variable ddhcswap_swapz -value 2
   grid $cf.rbx -row 1 -column 1 -sticky w
   grid $cf.rby -row 1 -column 2 -sticky w
   grid $cf.rbz -row 1 -column 3 -sticky w
   checkbutton $cf.neg -text "negate" -variable ddhcswap_negz
   grid $cf.neg -row 1 -column 4 -sticky w

   # Button
   frame .ddhcswap.frmbtn
   pack .ddhcswap.frmbtn -side top -fill x
   button .ddhcswap.frmbtn.btnapply -text "Swap coordinates/vertices" -command {
      eval ac3d ddhcswap_go $ddhcswap_swapx $ddhcswap_swapy $ddhcswap_swapz $ddhcswap_negx $ddhcswap_negy $ddhcswap_negz
   }
   pack .ddhcswap.frmbtn.btnapply -side left -fill x -expand 1

}

proc ddhcswap_dialog {} {

   global ddhcswap_swapx
   global ddhcswap_swapy
   global ddhcswap_swapz
   global ddhcswap_negx
   global ddhcswap_negy
   global ddhcswap_negz

   if ![winfo exists .ddhcswap] {
      set ddhcswap_swapx 0
      set ddhcswap_swapy 1
      set ddhcswap_swapz 2
      set ddhcswap_negx 0
      set ddhcswap_negy 0
      set ddhcswap_negz 0
      ddhcswap_makeframe
   }

   wm deiconify .ddhcswap
   centre_window_on_screen .ddhcswap

}

